//lRegen_FileHeading
//lRegen_FileHeading

     /********************************************************************
      *
      *   Source File:  colorset.c                                        
      *   Author:                                                         
      *   Module:                                                         
      *   Program Desc:                                                                                 
      *   Date:         Mon Feb 19 13:11:40 1996                          
      *   Language:     ANSI C
      *
      ********************************************************************/

#include ".\idoiface.h"


//lRegen_Variables

static BOOL bSetColor;

static BOOL bColorVisible = FALSE;

static HWND hColor;
HWND GetColorPaletteWnd()
{
   return hColor;
}

void SetObjectColor();
void SetTestColor(HWND);

//lRegen_Variables

VIEW     hViewcolorset;
HWND     hWndcolorset;
LRESULT CALLBACK EXPORT fncolorsetWndProc(HWND, UINT, WPARAM, LPARAM);

int fncolorset(HWND hParentWnd, UINT iData, void FAR *lpData)
{
   //lRegen_BeginFunction

   if(bColorVisible)
   {
      DestroyWindow(hColor);
      return 0;
   }

   //lRegen_BeginFunction

   //lRegen_InitDlg
   bSetColor = FALSE;
   //lRegen_InitDlg

   if(NULL == (hViewcolorset = vwCreateView(hInstance,
                   MAKEINTRESOURCE(colorset),
                   hParentWnd,
                   (VIEWPROC)fncolorsetWndProc,
                   NULL)))
   {
         //lRegen_Create
         //lRegen_Create
        return FALSE;
   }
   //lRegen_InitView
   //lRegen_InitView
   if((hWndcolorset = vwShowView(hViewcolorset)) == (HWND)-1)
   {
        MessageBox(NULL, "Unable to display view", "System Error",
                   MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
        return FALSE;
   }

   //lRegen_TermView
   //lRegen_TermView
   return(TRUE);
}

LRESULT CALLBACK EXPORT fncolorsetWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
GETVIEW;
   WORD CtlId;
   WORD Notify;
   HWND CtlWnd;

   //lRegen_WindowProcVariables
   //lRegen_WindowProcVariables

   switch(uMessage)
   {
      //lRegen_WndProc
      //lRegen_WndProc

      case WM_INITDIALOG :
         //lRegen_InitDialogBegin
         SetScrollRange(GetDlgItem(hWnd, IDC_TR), SB_CTL, 0, 255, TRUE);
         SetScrollRange(GetDlgItem(hWnd, IDC_TG), SB_CTL, 0, 255, TRUE);
         SetScrollRange(GetDlgItem(hWnd, IDC_TB), SB_CTL, 0, 255, TRUE);
         SetScrollRange(GetDlgItem(hWnd, IDC_BR), SB_CTL, 0, 255, TRUE);
         SetScrollRange(GetDlgItem(hWnd, IDC_BG), SB_CTL, 0, 255, TRUE);
         SetScrollRange(GetDlgItem(hWnd, IDC_BB), SB_CTL, 0, 255, TRUE);

         bColorVisible = TRUE;
         hColor = hWnd;

         bSetColor = FALSE;
         ReadColor();
         bSetColor = TRUE;
         EnableWindow(GetDlgItem(hWnd, IDC_APPLY), FALSE);
         //lRegen_InitDialogBegin
         //Regen_WM_InitDialog
         //Regen_WM_InitDialog
         return TRUE;

      case WM_HSCROLL :
         //Regen_WM_HSCROLL
         if(HIWORD(lParam))  // send by a scrollbar
         {
            switch(wParam)
            {
               case SB_LINEUP :
                  SetScrollPos(HIWORD(lParam), SB_CTL, GetScrollPos(HIWORD(lParam), SB_CTL) +1, TRUE);
                  break;
               case SB_LINEDOWN :
                  SetScrollPos(HIWORD(lParam), SB_CTL, GetScrollPos(HIWORD(lParam), SB_CTL) -1, TRUE);
                  break;
               case SB_PAGEUP :
                  SetScrollPos(HIWORD(lParam), SB_CTL, GetScrollPos(HIWORD(lParam), SB_CTL) +10, TRUE);
                  break;
               case SB_PAGEDOWN :
                  SetScrollPos(HIWORD(lParam), SB_CTL, GetScrollPos(HIWORD(lParam), SB_CTL) -10, TRUE);
                  break;
               case SB_THUMBTRACK :
                  SetScrollPos(HIWORD(lParam), SB_CTL, LOWORD(lParam), TRUE);
                  break;
            }
            SetTestColor(hWnd);
            EnableWindow(GetDlgItem(hWnd, IDC_APPLY), TRUE);
         }
         //Regen_WM_HSCROLL
         break;

      case WM_VSCROLL :
         //Regen_WM_VSCROLL
         //Regen_WM_VSCROLL
         break;

      case WM_COMMAND :
      #ifdef WIN32
         CtlId  = LOWORD(wParam);
         Notify = HIWORD(wParam);
         CtlWnd = (HWND)lParam;
      #else
         CtlId  = wParam;
         Notify = HIWORD(lParam);
         CtlWnd = (HWND)LOWORD(lParam);
      #endif
         switch(CtlId)
         {
            case IDC_TESTCOLOR :
               //Regen_IDC_TESTCOLOR
               //Regen_IDC_TESTCOLOR
               break; 

            case IDC_APPLY :
               //Regen_IDC_APPLY

               SetObjectColor();
               EnableWindow(GetDlgItem(hWnd, IDC_APPLY), FALSE);

               //Regen_IDC_APPLY
               break; 

            case IDC_TR :
               //Regen_IDC_TR
               //Regen_IDC_TR
               break; 

            case IDC_TG :
               //Regen_IDC_TG
               //Regen_IDC_TG
               break; 

            case IDC_TB :
               //Regen_IDC_TB
               //Regen_IDC_TB
               break; 

            case IDC_BR :
               //Regen_IDC_BR
               //Regen_IDC_BR
               break; 

            case IDC_BG :
               //Regen_IDC_BG
               //Regen_IDC_BG
               break; 

            case IDC_BB :
               //Regen_IDC_BB
               //Regen_IDC_BB
               break; 

            //lRegen_CustomCommand
            //lRegen_CustomCommand
            }
            break;

      case WM_DESTROY :
        //Regen_WM_Destroy
        bColorVisible = FALSE;
        hColor = 0;
        //Regen_WM_Destroy
         break;
   }
   return DefViewProc(hWnd, uMessage, wParam, lParam);
}

//Regen_CustomCode

void SetTestColor(HWND hWnd)
{
   COLORREF color, color2;
   int  R,G,B;


   R = GetScrollPos(GetDlgItem(hColor, IDC_TR), SB_CTL);
   G = GetScrollPos(GetDlgItem(hColor, IDC_TG), SB_CTL);
   B = GetScrollPos(GetDlgItem(hColor, IDC_TB), SB_CTL);
   color = RGB((BYTE)R,(BYTE)G,(BYTE)B);

   R = GetScrollPos(GetDlgItem(hColor, IDC_BR), SB_CTL);
   G = GetScrollPos(GetDlgItem(hColor, IDC_BG), SB_CTL);
   B = GetScrollPos(GetDlgItem(hColor, IDC_BB), SB_CTL);
   color2 = RGB((BYTE)R,(BYTE)G,(BYTE)B);

   vwSetFieldColors(vwGetView(hWnd), IDC_TESTCOLOR, color, color2, color, color2);
}

static int      item = 0;  // what object are we setting the color for?
#define COLOR_IDO    0
#define COLOR_ENTITY 1
#define COLOR_LINE   2

void ReadColor()
{
   HWND     hIDO;
   COLORREF color, color2;
   int      Rvalue, Gvalue, Bvalue;
   ENTITY   entity;
   RELATION relation;



   if(!hColor)  // color palette not visible
      return;

   EnableWindow(GetDlgItem(hColor, IDC_APPLY), FALSE);

   if(hIDO = GetActiveIDO())  // active IDO window found.
   {
      // try to get the current entity
      if(idoGetCurrentEntity(hIDO, &entity))
      {
         color  = idoEntityGetTextColor(&entity);
         color2 = idoEntityGetBackColor(&entity);
      }
      else
         // try to get the current line
         if(idoGetCurrentRelation(hIDO, &relation))
         {
            color  = idoRelationGetTextColor(&relation);
            color2 = idoRelationGetBackColor(&relation);
         }
         else
         {
            color  = idoGetBackColor(hIDO);
            color2 = idoGetGridLineColor(hIDO);
         }


      // update the window values
      Rvalue = (int)GetRValue(color);
      Gvalue = (int)GetGValue(color);
      Bvalue = (int)GetBValue(color);

      SetScrollPos(GetDlgItem(hColor, IDC_TR), SB_CTL, Rvalue, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_TG), SB_CTL, Gvalue, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_TB), SB_CTL, Bvalue, TRUE);

      Rvalue = (int)GetRValue(color2);
      Gvalue = (int)GetGValue(color2);
      Bvalue = (int)GetBValue(color2);

      SetScrollPos(GetDlgItem(hColor, IDC_BR), SB_CTL, Rvalue, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_BG), SB_CTL, Gvalue, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_BB), SB_CTL, Bvalue, TRUE);
   }
   else
   {
      // nothing is selected, ie no IDO exists
      SetScrollPos(GetDlgItem(hColor, IDC_TR), SB_CTL, 0, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_TG), SB_CTL, 0, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_TB), SB_CTL, 0, TRUE);

      SetScrollPos(GetDlgItem(hColor, IDC_BR), SB_CTL, 0, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_BG), SB_CTL, 0, TRUE);
      SetScrollPos(GetDlgItem(hColor, IDC_BB), SB_CTL, 0, TRUE);
   }

   // update the window
   vwPaintViewFields(vwGetView(hColor));
   SetTestColor(hColor);
}

void SetObjectColor()
{
   HWND hIDO;
   COLORREF color, color2;
   int  R,G,B;
   ENTITY entity;
   RELATION relation;


   if(!hColor)
      return;
   if(!bSetColor)
      return;

   if(hIDO = GetActiveIDO())
   {
      R = GetScrollPos(GetDlgItem(hColor, IDC_TR), SB_CTL);
      G = GetScrollPos(GetDlgItem(hColor, IDC_TG), SB_CTL);
      B = GetScrollPos(GetDlgItem(hColor, IDC_TB), SB_CTL);
      color = RGB((BYTE)R,(BYTE)G,(BYTE)B);

      R = GetScrollPos(GetDlgItem(hColor, IDC_BR), SB_CTL);
      G = GetScrollPos(GetDlgItem(hColor, IDC_BG), SB_CTL);
      B = GetScrollPos(GetDlgItem(hColor, IDC_BB), SB_CTL);
      color2 = RGB((BYTE)R,(BYTE)G,(BYTE)B);

      // try to get the current entity
      if(idoGetCurrentEntity(hIDO, &entity))
      {
         idoIterateSelectedEntityFirst(hIDO);
         while(idoIterateSelectedEntityNext(hIDO, &entity))
         {
            idoEntitySetTextColor(&entity, color);
            idoEntitySetBackColor(&entity, color2);
         }
      }
      else
         // try to get the current line
         if(idoGetCurrentRelation(hIDO, &relation))
         {
            idoRelationSetTextColor(&relation, color);
            idoRelationSetBackColor(&relation, color2);
         }
         else
         {
            idoSetGridLineColor(hIDO, color);
            idoSetBackColor(hIDO, color2);
         }


      InvalidateRect(hIDO, NULL, TRUE);
      UpdateWindow(hIDO);
   }
}

//Regen_CustomCode
