//lRegen_FileHeading
//lRegen_FileHeading

#ifndef __idoiface_MAIN_H
#define __idoiface_MAIN_H


     /********************************************************************
      *
      *   Source File:  mainapp.h                                         
      *   Author:                                                         
      *   Module:       C++ Header file for IDOIFACE application          
      *   Program Desc:                                                                                 
      *   Date:         Tue Jan 23 17:38:47 1996                          
      *   Language:     OWL C++ 2.5
      *
      ********************************************************************/

#include ".\idoiface.h"

//Regen_App_Include
//Regen_App_Include

// --------------- Main Window Object ---------------

class TApp : public TApplication
{
private:
   //Regen_App_Private
   //Regen_App_Private

public:
   TApp();
public:
   virtual ~TApp();

   virtual void InitMainWindow();
   virtual void InitInstance();
   //Regen_AppClass
   //Regen_AppClass
};

//Regen_TApp
//Regen_TApp
// --------------- Client Window Object ---------------
class TMDIClientWin : public TMDIClient
{
public:
      TMDIClientWin(TModule *module = 0)
      {
        //Regen_TMDIClientWinInit
        //Regen_TMDIClientWinInit
      }
      ~TMDIClientWin ()
      {
        //Regen_TMDIClientWinEnd
        //Regen_TMDIClientWinEnd
      }
};

// --------------- TDecorated MDI Frame Window Object ---------------
class MDIFrame : public TDecoratedMDIFrame
{
public:
   MDIFrame(const char far *title, TResId menuResId, TMDIClient
                 &clientWnd = *new TMDIClient, BOOL trackMenuSelection = FALSE,
                 TModule* module = 0) : TDecoratedMDIFrame(title, menuResId, clientWnd,
                                                           trackMenuSelection, module)
   {
     Printer  = 0;
     Printing = FALSE;

     //Regen_MainFrame
     //Regen_MainFrame
   }
   //Regen_MainFrameClass
   //Regen_MainFrameClass

public:
   TPrinter   *Printer;
   BOOL       Printing;

protected:
   virtual void SetupWindow();

protected:
   void CmCM_FILENEW();
   void CmCM_FILEOPEN();
   void CmIDM_CLOSE();
   void CmIDM_RESET();
   void CmCM_FILESAVE();
   void CmIDM_SAVEAS();
   void CmIDM_RESETPALETTE();
   void CmIDM_LOADPALETTE();
   void CmIDM_SAVEPALETTE();
   void CmIDM_OPENJOBSFILE();
   void CmCM_FILEPRINT();
   void CmCM_EXIT();
   void CmIDM_CUT();
   void CmIDM_COPY();
   void CmIDM_PASTE();
   void CmIDM_ZOOMIN();
   void CmIDM_ZOOMOUT();
   void CmIDM_ZOOMTOFITWINDOW();
   void CmIDM_USEIDOMENUS();
   void CmIDM_GRIDLINES();
   void CmIDM_SNAPTOGRID();
   void CmIDM_EDITMODE();
   void CmIDM_DISPLAYMESSAGES();
   void CmIDM_ADDENTITY();
   void CmIDM_ADDRELATION();
   void CmIDM_DELETEENTITY();
   void CmIDM_SETCURRENTENTITYTEXT();
   void CmIDM_COLOR();
   void CmIDM_GRID();
   void CmIDM_TEXT();
   void CmIDM1_COLOR();
   void CmIDM_SHAPE();
   void CmIDM_GRAPHIC();
   void CmIDM1_TEXT();
   void CmIDM1_SHAPE();
   void CmIDM2_COLOR();
   void CmIDM_TOOLPALETTE();
   void CmIDM_COLORPALETTE();
   void CmIDM_ALIGNMENTPALETTE();
   void CmIDM_REFRESHIDO();
   void CmCM_CASCADECHILDREN();
   void CmCM_TILECHILDREN();
   void CmCM_ARRANGEICONS();
   void CmCM_CLOSECHILDREN();
   void CmIDM_HELP();
   void CmIDM_ABOUT();
   void EvDestroy ();
   void EvInitMenuPopup (HMENU hPopupMenu, UINT index, BOOL sysMenu);
   void EvSize (UINT sizeType, TSize& size);
   void EvMenuSelect (UINT menuItemId, UINT flags, HMENU hMenu);
   //Regen_MsgMainClass
   //Regen_MsgMainClass


   //Regen_MainClass
   //Regen_MainClass

   DECLARE_RESPONSE_TABLE(MDIFrame);
};

//Regen_AppClassHd
//Regen_AppClassHd

#endif     // __idoiface_MAIN_H
