# 
#  Makefile for ANSI C application : travel
# 
SRCDIR = ./
INCDIR = ./
OBJDIR = ./
RESDIR = ./
LIBDIR = ./
EXEDIR = ./
LNKRSP = @.\travel.lnk

# Error listing file
ERROUT    = >> Errors

CC        = cl.exe
LINK      = link.exe
RC        = rc.exe
IMPLIB    = implib.exe
CFLAGS    = -D_DEBUG -DWIN31 -nologo -c -Gs -Od -W3 -Zipe -AL -GA
CDEFINES  = 
LINKFLAGS = /nod /B /CO
COMPILE   = $(CC) $(CFLAGS) $(CDEFINES)

ALL : $(EXEDIR)travel.exe

.Silent:

$(OBJDIR)travel.obj : $(SRCDIR)travel.c
   echo compiling travel.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)travel.c $(ERROUT)

$(OBJDIR)Abouttra.obj : $(SRCDIR)Abouttra.c
   echo compiling Abouttra.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)Abouttra.c $(ERROUT)

$(OBJDIR)distance.obj : $(SRCDIR)distance.c
   echo compiling distance.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)distance.c $(ERROUT)

$(OBJDIR)newpath.obj : $(SRCDIR)newpath.c
   echo compiling newpath.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)newpath.c $(ERROUT)

$(OBJDIR)newcity.obj : $(SRCDIR)newcity.c
   echo compiling newcity.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)newcity.c $(ERROUT)

$(RESDIR)travel.res : $(RESDIR)travel.rc $(INCDIR)Resource.h  $(RESDIR)*.dlg 
   echo compiling Resources...
   $(RC) -r $(RESDIR)travel.rc $(ERROUT)

$(EXEDIR)travel.exe : $(OBJDIR)travel.obj \
   $(RESDIR)travel.res \
   $(LIBDIR)travel.def \
   $(OBJDIR)Abouttra.obj \
   $(OBJDIR)distance.obj \
   $(OBJDIR)newpath.obj \
   $(OBJDIR)newcity.obj \
   
    echo linking...
    $(LINK) $(LINKFLAGS) $(LNKRSP) $(ERROUT)
    echo Combining resources...
    $(RC) -K $(RESDIR)travel.res $(EXEDIR)travel.exe $(ERROUT)
   echo Finished
#*******************************************************************#
