//lRegen_FileHeading
//lRegen_FileHeading

     /********************************************************************
      *
      *   Source File:  addentit.c                                        
      *   Author:                                                         
      *   Module:                                                         
      *   Program Desc:                                                                                 
      *   Date:         Mon Feb 19 13:11:38 1996                          
      *   Language:     ANSI C
      *
      ********************************************************************/

#include ".\idoiface.h"


//lRegen_Variables
//lRegen_Variables

typedef struct tagADDENTITYDATA
{
   char            UNAME[80 + 1];
   long            UID;
   char            U_TEXT[80 + 1];
   char            szUCLASSSelection[80];
   CBARRAY         UCLASS;
}ADDENTITYDATA, FAR* LPADDENTITYDATA;

VIEW     hViewaddentity;
HWND     hWndaddentity;
// Data Pointer for Dialog control data elements
HGLOBAL haddentityData = NULL;
LPADDENTITYDATA lpaddentityData = NULL;
LRESULT CALLBACK EXPORT fnaddentityWndProc(HWND, UINT, WPARAM, LPARAM);

int fnaddentity(HWND hParentWnd, UINT iData, void FAR *lpData)
{
   int   ReturnCode;

   //lRegen_BeginFunction
   //lRegen_BeginFunction

   // Associate Data elements with view
   if(NULL == lpaddentityData)
   {
      haddentityData = GlobalAlloc(GHND, sizeof(ADDENTITYDATA));
      if(NULL == haddentityData)
         return FALSE;
      lpaddentityData = (LPADDENTITYDATA)GlobalLock(haddentityData);
   }
   //lRegen_InitDlg
   //lRegen_InitDlg

   if(NULL == (hViewaddentity = vwCreateView(hInstance,
                   MAKEINTRESOURCE(addentity),
                   hParentWnd,
                   (VIEWPROC)fnaddentityWndProc,
                   NULL)))
   {
         //lRegen_Create
         //lRegen_Create
        return FALSE;
   }
   vwSetFieldVar(hViewaddentity, IDC_UNAME, lpaddentityData->UNAME);
   vwSetFieldVar(hViewaddentity, IDC_UID, &lpaddentityData->UID);
   vwSetFieldVar(hViewaddentity, IDC_TEXT, lpaddentityData->U_TEXT);
   lpaddentityData->UCLASS.SelectedString = lpaddentityData->szUCLASSSelection;
   vwSetFieldVar(hViewaddentity, IDC_UCLASS, &lpaddentityData->UCLASS);
   //lRegen_InitView
   //lRegen_InitView
   if((ReturnCode = vwShowModalView(hViewaddentity)) == -1)
   {
        MessageBox(NULL, "Unable to display view", "System Error",
                   MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
        return FALSE;
   }

   //lRegen_TermView
   //lRegen_TermView
   // Free Data Pointer for Dialog control data elements
   if(NULL != haddentityData)
   {
      GlobalUnlock(haddentityData);
      GlobalFree(haddentityData);
      haddentityData  = 0;
      lpaddentityData = NULL;
   }
   return(ReturnCode);
}

LRESULT CALLBACK EXPORT fnaddentityWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
GETVIEW;
   WORD CtlId;
   WORD Notify;
   HWND CtlWnd;

   //lRegen_WindowProcVariables

   char szClassName[100+1];

   //lRegen_WindowProcVariables

   switch(uMessage)
   {
      //lRegen_WndProc
      //lRegen_WndProc

      case WM_INITDIALOG :
         //lRegen_InitDialogBegin
         {
            HWND hIDO = GetActiveIDO();


            if(IsWindow(hIDO))
            {
               if(idoIterateEntityClassFirst(hIDO))
                  while(idoIterateEntityClassNext(hIDO, szClassName))
                     SendDlgItemMessage(hWnd, IDC_UCLASS, CB_ADDSTRING, 0, (LPARAM)(LPSTR)szClassName);
            }
         }
         //lRegen_InitDialogBegin
         //Regen_WM_InitDialog
         //Regen_WM_InitDialog
         return TRUE;

      case WM_COMMAND :
      #ifdef WIN32
         CtlId  = LOWORD(wParam);
         Notify = HIWORD(wParam);
         CtlWnd = (HWND)lParam;
      #else
         CtlId  = wParam;
         Notify = HIWORD(lParam);
         CtlWnd = (HWND)LOWORD(lParam);
      #endif
         switch(CtlId)
         {
            case IDC_UNAME :
               //Regen_IDC_UNAME
               //Regen_IDC_UNAME
               break; 

            case IDC_TEXT :
               //Regen_IDC_TEXT
               //Regen_IDC_TEXT
               break; 

            case IDOK :
               //Regen_IDOK

               vwUpdateApp(View);

               /*
                *   Add an entity.
                */
               idoAddEntityFromClass(GetActiveIDO(),
                                     lpaddentityData->UID,
                                     lpaddentityData->UNAME,
                                     lpaddentityData->szUCLASSSelection,
                                     lpaddentityData->U_TEXT,
                                     0, 0, 0, 0);

               //Regen_IDOK
               break; 

            case IDCANCEL :
               //Regen_IDCANCEL
               //Regen_IDCANCEL
               break; 

            case IDC_UID :
               //Regen_IDC_UID
               //Regen_IDC_UID
               break; 

            case IDC_UCLASS :
               //Regen_IDC_UCLASS
               //Regen_IDC_UCLASS
               break; 

            //lRegen_CustomCommand
            //lRegen_CustomCommand
            }
            break;

      case WM_DESTROY :
        //Regen_WM_Destroy
        //Regen_WM_Destroy
         // Free Data Pointer for Dialog control data elements
         if(NULL != haddentityData)
         {
            GlobalUnlock(haddentityData);
            GlobalFree(haddentityData);
            haddentityData  = 0;
            lpaddentityData = NULL;
         }
         break;
   }
   return DefViewProc(hWnd, uMessage, wParam, lParam);
}

//Regen_CustomCode
//Regen_CustomCode
