//lRegen_FileHeading
//lRegen_FileHeading

     /********************************************************************
      *
      *   Source File:  Banner.c                                          
      *   Author:                                                         
      *   Module:       Source for idoiface application                   
      *   Program Desc:                                                                                 
      *   Date:         Wed Feb 28 12:01:48 1996                          
      *   Language:     ANSI C
      *
      ********************************************************************/

#include ".\idoiface.h"


//lRegen_Variables
//lRegen_Variables

VIEW     hViewBanner;
HWND     hWndBanner;
LRESULT CALLBACK EXPORT fnBannerWndProc(HWND, UINT, WPARAM, LPARAM);

int fnBanner(HWND hParentWnd, UINT iData, void FAR *lpData)
{
   int   ReturnCode;

   //lRegen_BeginFunction
   //lRegen_BeginFunction

   //lRegen_InitDlg
   //lRegen_InitDlg

   if(NULL == (hViewBanner = vwCreateView(hInstance,
                   MAKEINTRESOURCE(Banner),
                   hParentWnd,
                   (VIEWPROC)fnBannerWndProc,
                   NULL)))
   {
         //lRegen_Create
         //lRegen_Create
        return FALSE;
   }
   //lRegen_InitView
   //lRegen_InitView
   if((ReturnCode = vwShowModalView(hViewBanner)) == -1)
   {
        MessageBox(NULL, "Unable to display view", "System Error",
                   MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
        return FALSE;
   }

   //lRegen_TermView
   //lRegen_TermView
   return(ReturnCode);
}

LRESULT CALLBACK EXPORT fnBannerWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
GETVIEW;
   WORD CtlId;
   WORD Notify;
   HWND CtlWnd;

   //lRegen_WindowProcVariables
   //lRegen_WindowProcVariables

   switch(uMessage)
   {
      //lRegen_WndProc
      //lRegen_WndProc

      case WM_INITDIALOG :
         //lRegen_InitDialogBegin

         vwSetViewPosition(View, 0, 0, 0, 0, VW_SCREENCENTER);
         SetTimer(hWnd, 1234, 3500, NULL);

         //lRegen_InitDialogBegin
         //Regen_WM_InitDialog
         //Regen_WM_InitDialog
         return TRUE;

      case WM_TIMER :
         //Regen_WM_TIMER
         switch(wParam)
         {
            case 1234 :
               KillTimer(hWnd, 1234);
               vwEndModalView(View, TRUE);
               break;
         }
         //Regen_WM_TIMER
         break;

      case WM_COMMAND :
      #ifdef WIN32
         CtlId  = LOWORD(wParam);
         Notify = HIWORD(wParam);
         CtlWnd = (HWND)lParam;
      #else
         CtlId  = wParam;
         Notify = HIWORD(lParam);
         CtlWnd = (HWND)LOWORD(lParam);
      #endif
         switch(CtlId)
         {
            case IDC_TEXT3D1 :
               //Regen_IDC_TEXT3D1
               //Regen_IDC_TEXT3D1
               break; 

            case IDC_ICON1 :
               //Regen_IDC_ICON1
               //Regen_IDC_ICON1
               break; 

            //lRegen_CustomCommand
            //lRegen_CustomCommand
            }
            break;

      case WM_DESTROY :
        //Regen_WM_Destroy
        //Regen_WM_Destroy
         break;
   }
   return DefViewProc(hWnd, uMessage, wParam, lParam);
}

//Regen_CustomCode
//Regen_CustomCode
