//lRegen_FileHeading
//lRegen_FileHeading

     /********************************************************************
      *
      *   Source File:  deleteen.c                                        
      *   Author:                                                         
      *   Module:                                                         
      *   Program Desc:                                                                                 
      *   Date:         Mon Feb 19 13:11:38 1996                          
      *   Language:     ANSI C
      *
      ********************************************************************/

#include ".\idoiface.h"


//lRegen_Variables
//lRegen_Variables

VIEW     hViewdeleteentity;
HWND     hWnddeleteentity;
LRESULT CALLBACK EXPORT fndeleteentityWndProc(HWND, UINT, WPARAM, LPARAM);

int fndeleteentity(HWND hParentWnd, UINT iData, void FAR *lpData)
{
   int   ReturnCode;

   //lRegen_BeginFunction
   //lRegen_BeginFunction

   //lRegen_InitDlg
   //lRegen_InitDlg

   if(NULL == (hViewdeleteentity = vwCreateView(hInstance,
                   MAKEINTRESOURCE(deleteentity),
                   hParentWnd,
                   (VIEWPROC)fndeleteentityWndProc,
                   NULL)))
   {
         //lRegen_Create
         //lRegen_Create
        return FALSE;
   }
   //lRegen_InitView
   //lRegen_InitView
   if((ReturnCode = vwShowModalView(hViewdeleteentity)) == -1)
   {
        MessageBox(NULL, "Unable to display view", "System Error",
                   MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
        return FALSE;
   }

   //lRegen_TermView
   //lRegen_TermView
   return(ReturnCode);
}

LRESULT CALLBACK EXPORT fndeleteentityWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
GETVIEW;
   WORD CtlId;
   WORD Notify;
   HWND CtlWnd;

   //lRegen_WindowProcVariables
   //lRegen_WindowProcVariables

   switch(uMessage)
   {
      //lRegen_WndProc
      //lRegen_WndProc

      case WM_INITDIALOG :
         //lRegen_InitDialogBegin
         {
            HWND hIDO = GetActiveIDO();
            ENTITY entity;
            char szNum[20+1];


            if(IsWindow(hIDO))
            {
               if(idoIterateEntityFirst(hIDO))
                  while(idoIterateEntityNext(hIDO, &entity))
                  {
                     wsprintf(szNum, "%d", entity.id);
                     SendDlgItemMessage(hWnd, IDC_EID, CB_ADDSTRING, 0, (LPARAM)(LPSTR)szNum);
                     SendDlgItemMessage(hWnd, IDC_ENAME, CB_ADDSTRING, 0, (LPARAM)(LPSTR)entity.name);
                  }
            }
         }
         //lRegen_InitDialogBegin
         //Regen_WM_InitDialog
         //Regen_WM_InitDialog
         return TRUE;

      case WM_COMMAND :
      #ifdef WIN32
         CtlId  = LOWORD(wParam);
         Notify = HIWORD(wParam);
         CtlWnd = (HWND)lParam;
      #else
         CtlId  = wParam;
         Notify = HIWORD(lParam);
         CtlWnd = (HWND)LOWORD(lParam);
      #endif
         switch(CtlId)
         {
            case IDC_ENAME :
                  switch(Notify)
                  {
                     case CBN_SELCHANGE :
                        //Regen_IDC_ENAME_CBN_SELCHANGE
                        {
                           int index;

                           index = (int)SendDlgItemMessage(hWnd, IDC_ENAME, CB_GETCURSEL, 0, 0L);
                           SendDlgItemMessage(hWnd, IDC_EID, CB_SETCURSEL, index, 0L);
                        }
                        //Regen_IDC_ENAME_CBN_SELCHANGE
                        break;

                  }
                  break;
            case IDC_EID :
                  switch(Notify)
                  {
                     case CBN_SELCHANGE :
                        //Regen_IDC_EID_CBN_SELCHANGE
                        {
                           int index;

                           index = (int)SendDlgItemMessage(hWnd, IDC_EID, CB_GETCURSEL, 0, 0L);
                           SendDlgItemMessage(hWnd, IDC_ENAME, CB_SETCURSEL, index, 0L);
                        }
                        //Regen_IDC_EID_CBN_SELCHANGE
                        break;

                  }
                  break;
            case IDOK :
               //Regen_IDOK
               {
                  ENTITY entity;
                  int index;
                  char szNum[20+1];
                  char szName[100+1];
                  int  num;


                  index = (int)SendDlgItemMessage(hWnd, IDC_ENAME, CB_GETCURSEL, 0, 0L);
                  SendDlgItemMessage(hWnd, IDC_ENAME, CB_GETLBTEXT, index, (LPARAM)(LPSTR)szName);
                  index = (int)SendDlgItemMessage(hWnd, IDC_EID, CB_GETCURSEL, 0, 0L);
                  SendDlgItemMessage(hWnd, IDC_EID, CB_GETLBTEXT, index, (LPARAM)(LPSTR)szNum);
                  num = atoi(szNum);


                  /*
                   *   Delete an entity.
                   */
                  idoGetEntity(GetActiveIDO(), num, szName, &entity);
                  idoDeleteEntity(GetActiveIDO(), &entity);
               }
               //Regen_IDOK
               break; 

            case IDCANCEL :
               //Regen_IDCANCEL
               //Regen_IDCANCEL
               break; 

            //lRegen_CustomCommand
            //lRegen_CustomCommand
            }
            break;

      case WM_DESTROY :
        //Regen_WM_Destroy
        //Regen_WM_Destroy
         break;
   }
   return DefViewProc(hWnd, uMessage, wParam, lParam);
}

//Regen_CustomCode
//Regen_CustomCode
