//lRegen_FileHeading
//lRegen_FileHeading

     /********************************************************************
      *
      *   Source File:  TopToolb.c                                        
      *   Author:                                                         
      *   Module:       Source for idoiface application                   
      *   Program Desc:                                                                                 
      *   Date:         Mon Feb 19 13:11:37 1996                          
      *   Language:     ANSI C
      *
      ********************************************************************/

#include ".\idoiface.h"


//lRegen_Variables

extern BOOL bMsg;

//lRegen_Variables

VIEW     hViewTopToolbar;
HWND     hWndTopToolbar;
LRESULT CALLBACK EXPORT fnTopToolbarWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
GETVIEW;
   WORD CtlId;
   WORD Notify;
   HWND CtlWnd;

   //lRegen_WindowProcVariables
   //lRegen_WindowProcVariables

   switch(uMessage)
   {
      //lRegen_WndProc
      //lRegen_WndProc

      case WM_INITDIALOG :
         //lRegen_InitDialogBegin
         //lRegen_InitDialogBegin
         //Regen_WM_InitDialog
         //Regen_WM_InitDialog
         return TRUE;

      case WM_COMMAND :
      #ifdef WIN32
         CtlId  = LOWORD(wParam);
         Notify = HIWORD(wParam);
         CtlWnd = (HWND)lParam;
      #else
         CtlId  = wParam;
         Notify = HIWORD(lParam);
         CtlWnd = (HWND)LOWORD(lParam);
      #endif
         switch(CtlId)
         {
            case IDC_NEW :
               //Regen_IDC_NEW
               SENDCOMMAND(GetParent(hWnd), CM_FILENEW, 0, 0);
               //Regen_IDC_NEW
               break; 

            case IDC_OPEN :
               //Regen_IDC_OPEN
               SENDCOMMAND(GetParent(hWnd), CM_FILEOPEN, 0, 0);
               //Regen_IDC_OPEN
               break; 

            case IDC_SAVE :
               //Regen_IDC_SAVE
               SENDCOMMAND(GetParent(hWnd), CM_FILESAVE, 0, 0);
               //Regen_IDC_SAVE
               break; 

            case IDC_CUT :
               //Regen_IDC_CUT
               if(GetActiveIDO())
                  SendMessage(GetActiveIDO(), WM_CUT, 0, 0L);
               else
                  MessageBeep(0);
               //Regen_IDC_CUT
               break; 

            case IDC_COPY :
               //Regen_IDC_COPY
               if(GetActiveIDO())
                  SendMessage(GetActiveIDO(), WM_COPY, 0, 0L);
               else
                  MessageBeep(0);
               //Regen_IDC_COPY
               break; 

            case IDC_PASTE :
               //Regen_IDC_PASTE
               if(GetActiveIDO())
                  SendMessage(GetActiveIDO(), WM_PASTE, 0, 0L);
               else
                  MessageBeep(0);
               //Regen_IDC_PASTE
               break; 

            case IDC_ZOOMIN :
               //Regen_IDC_ZOOMIN
               SENDCOMMAND(GetParent(hWnd), IDM_ZOOMIN, 0, 0);
               //Regen_IDC_ZOOMIN
               break; 

            case IDC_ZOOMOUT :
               //Regen_IDC_ZOOMOUT
               SENDCOMMAND(GetParent(hWnd), IDM_ZOOMOUT, 0, 0);
               //Regen_IDC_ZOOMOUT
               break; 

            //lRegen_CustomCommand
            //lRegen_CustomCommand
            }
            break;

      case WM_DESTROY :
        //Regen_WM_Destroy
        //Regen_WM_Destroy
         break;
   }
   return DefViewProc(hWnd, uMessage, wParam, lParam);
}

//Regen_CustomCode
//Regen_CustomCode
